'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var MOBX_FORMS = exports.MOBX_FORMS = 'mobxForms';

var INPUT_PROPS = exports.INPUT_PROPS = ['autocomplete', 'checked', 'height', 'name', 'pattern', 'placeholder', 'readonly', 'required', 'size', 'selected', 'spellCheck', 'step', 'type', 'value', 'width', 'onChange', 'onFocus', 'onBlur'];

var META_PROPS = exports.META_PROPS = ['active', 'dirty', 'error', 'touched', 'visited'];

var IGNORE_PROPS = exports.IGNORE_PROPS = [].concat(INPUT_PROPS, META_PROPS, ['component', 'defaultValue', 'index', 'normalize', 'validate']);

var ARRAY_IGNORE_PROPS = exports.ARRAY_IGNORE_PROPS = ['name', 'validate', 'defaultValue'];