'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor;

var _mobx = require('mobx');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _FormStore = require('./containers/FormStore');

var _FormStore2 = _interopRequireDefault(_FormStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var FormsStore = (_class = function () {
  function FormsStore() {
    _classCallCheck(this, FormsStore);

    _initDefineProp(this, 'forms', _descriptor, this);
  }

  _createClass(FormsStore, [{
    key: 'addForm',


    /**
     * @protected
     * @param name: string - name of the form
     */
    value: function addForm(name) {
      (0, _invariant2.default)(!this.forms[name], '[mobx-forms] Tried to add a Form \'' + name + '\' twice. Form names must be unique!');
      this.forms[name] = new _FormStore2.default();
    }

    /**
     * @protected
     * @param name: string - name of the form
     */

  }, {
    key: 'removeForm',
    value: function removeForm(name) {
      delete this.forms[name];
    }
  }]);

  return FormsStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'forms', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
})), _class);
exports.default = FormsStore;